<script setup>
import { computed, shallowRef } from 'vue';
import Game from '../../game';
import FilterBox from '../components/filterbox.vue';
import { locked } from '../itemsBase';
import { TRY_BUY } from '../../events';
import { gameEvents } from '../../events';
import { useRollOver } from '../../store/popups';

const { itemOver } = useRollOver();
/**
 * @property {Item[]} filtered - filtered search results.
 */
const filtered = shallowRef(null);

const potions = computed(() => { return Game.state.potions.filter(v => !locked(v)); });

</script>

<template>
<div class="potions">

	<FilterBox v-model="filtered" :items="potions" min-items="7" />

	<div class="potion-col">
		<div v-for="it in filtered" class="separate"
			:key="'sect-pot-' + it.id" @mouseenter.capture.stop="itemOver($event, it)">

			<span>{{ it.name.toTitleCase() }}</span>

			<button v-if="it.buy && !it.owned"
				:disabled="!it.canBuy(Game) || (Game.state.inventory.full() && !Game.state.inventory.findMatch(it))"
				@click="gameEvents.emit(TRY_BUY, it)">🔒</button>
			<button v-else
				:disabled="!it.canUse() || (Game.state.inventory.full() && !Game.state.inventory.findMatch(it))"
				@click="gameEvents.emit('craft', it)">Brew</button>

		</div>

	</div>

</div>
</template>


<style scoped>
div.potions .potion-col {
	display: grid;
	grid-template-columns: repeat(auto-fit, minmax(10rem, 0.5fr));
	column-gap: var(--lg-gap);
	overflow-x: hidden;
	width: 100%;
}

div.flex-col .separate {
	width: 48%;
}

div.potions {
	padding: 0 1rem;

}
</style>